@echo off

rem Edit this to specify JDK version.

rem if you haven't set JAVA_HOME either install it in your JRules, please set it here.
rem set JAVA_HOME=xxxxx

rem Edit this to specfiy JRules version
set JRULES_HOME=C:\ILOG\JRules673

rem Edit this to specify Ant version
set ANT_HOME=%JRULES_HOME%\shared\tools\ant


rem ----------------------------------------------------------------------
rem Setup PROJECT_HOME environment
rem ----------------------------------------------------------------------
set CURRENT_DIR=%cd%
cd /d "%~dp0.."
set PROJECT_HOME=%cd%
cd /d "%CURRENT_DIR%"


rem -----------------------------------------------------------------
rem Check if JAVA_HOME is valid
rem -----------------------------------------------------------------
:check_jdk
echo -------
if "X%JAVA_HOME%"=="X" goto no_java_home
set JAVA_EXE="%JAVA_HOME%\bin\java.exe"
if not exist %JAVA_EXE% goto no_java_exe
echo JAVA_HOME is set, using JDK in %JAVA_HOME%
goto check_ant

:no_java_exe
echo Java executable not found in JAVA_HOME
echo Reverting to default java executable on search path
set JAVA_HOME=%JRULES_HOME%\jdk
if not exist %JAVA_HOME% goto no_jdk
set JAVA_EXE=java
goto check_ant

:no_java_home
echo JAVA_HOME is not set, using JRules Default
set JAVA_HOME=%JRULES_HOME%\jdk
if not exist %JAVA_HOME% goto no_jdk
set JAVA_EXE=java


rem -----------------------------------------------------------------
rem Check if ANT_HOME is valid
rem -----------------------------------------------------------------
:check_ant
echo -------
if "X%ANT_HOME%"=="X" goto no_ant_home
for %%i in ("%ANT_HOME%") do set ANT_HOME=%%~fsi
set ANT_EXE=%ANT_HOME%\bin\ant.bat
goto call_ant

:no_ant_home
echo ANT cannot be found, please specify ANT_HOME in check-env.cmd
pause
exit

:no_jdk
echo JDK cannot be found, please specify JAVA_HOME in check-env.cmd
pause
exit

:call_ant
echo Using ANT version:
call %ANT_EXE% -version
echo -------

:end
