/*
 * Copyright (C) ILOG 2006. All rights reserved.
 * 
 * THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OR ANY KIND
 * EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MECHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
 */
package ilog.contrib.rules.bomdomainpopulate;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.ResourceBundle;

public class DatabaseMappings {

	// various suffixes that are used in the schema mapping
	private static final String TABLE_SUFFIX = ".table";

	private static final String ITEM_SUFFIX = ".itemColumn";

	private static final String VERBALIZATION_SUFFIX = ".verbalizationColumn";

	private static final String B2X_SUFFIX = ".b2xColumn";

	// private static Map<String, String> mappings = null;
	private static Map mappings = null;

	public DatabaseMappings() {
		ResourceBundle bundle = ResourceBundle.getBundle(getClass().getName());
		if (null == mappings) {
			// mappings = new HashMap<String, String>();
			mappings = new HashMap();

			for (Enumeration keys = bundle.getKeys(); keys.hasMoreElements();) {
				final String key = (String) keys.nextElement();
				final String value = bundle.getString(key);

				mappings.put(key, value);
			}
		}
	}

	public String getTableName(String domainClass) {
		String key = domainClass + TABLE_SUFFIX;
		// return mappings.get(key);
		return (String) mappings.get(key);
	}

	public String getItemColumnName(String domainClass) {
		String key = domainClass + ITEM_SUFFIX;
		// return mappings.get(key);
		return (String) mappings.get(key);
	}

	public String getVerbalizationColumnName(String domainClass) {
		String key = domainClass + VERBALIZATION_SUFFIX;
		// return mappings.get(key);
		return (String) mappings.get(key);
	}

	public String getB2XColumnName(String domainClass) {
		String key = domainClass + B2X_SUFFIX;
		// return mappings.get(key);
		return (String) mappings.get(key);
	}
}
