/*
 * Copyright (C) ILOG 2006. All rights reserved.
 * 
 * THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OR ANY KIND
 * EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MECHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
 */
package ilog.contrib.rules.bomdomainpopulate.util;

/**
 * Simple log that logs messages to System.err. Used as a fallback if logging
 * not configured properly.
 */
public class SystemErrLogger extends AbstractLogger {

	private static ILogger instance;

	public static ILogger getInstance() {
		if (null == instance) {
			instance = new SystemErrLogger();
		}
		return instance;
	}

	public void log(String message, Throwable t) {
		System.err.print(message);
		if (null != t) {
			t.printStackTrace(System.err);
		}
	}
}
