/*
 * Copyright (C) ILOG 2006. All rights reserved.
 * 
 * THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OR ANY KIND
 * EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES
 * OF MECHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE. 
 */
package ilog.contrib.rules.studio.bomdomainpopulate;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * The main plugin class to be used in the desktop.
 */
public class BomDomainPopulatePlugin extends AbstractUIPlugin {

	// The shared instance.
	public static BomDomainPopulatePlugin plugin;

	// Resource bundle.
	private ResourceBundle resourceBundle;

	/**
	 * The constructor.
	 */
	public BomDomainPopulatePlugin() {
		super();
		plugin = this;
		try {
			resourceBundle = ResourceBundle
					.getBundle("ilog.contrib.rules.studio.bomdomainpopulate.BomDomainPopulatePluginResources");
		} catch (MissingResourceException x) {
			resourceBundle = null;
		}
	}

	/**
	 * This method is called upon plug-in activation
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
	}

	/**
	 * This method is called when the plug-in is stopped
	 */
	public void stop(BundleContext context) throws Exception {
		super.stop(context);
	}

	/**
	 * Returns the shared instance.
	 */
	public static BomDomainPopulatePlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns the string from the plugin's resource bundle, or 'key' if not
	 * found.
	 */
	public static String getResourceString(String key) {
		ResourceBundle bundle = BomDomainPopulatePlugin.getDefault()
				.getResourceBundle();
		try {
			return (bundle != null) ? bundle.getString(key) : key;
		} catch (MissingResourceException e) {
			return key;
		}
	}

	/**
	 * Returns the plugin's resource bundle,
	 */
	public ResourceBundle getResourceBundle() {
		return resourceBundle;
	}

	/**
	 * Logs the given throwable exception with no specific message.
	 */
	public void log(Throwable throwable) {
		log(null, throwable);
	}

	/**
	 * Logs the given throwable exception.
	 */
	public void log(String msg, Throwable throwable) {
		String reportMsg = throwable.getMessage() != null ? throwable
				.getMessage() : "";
		if (msg != null)
			reportMsg = msg + "\n" + reportMsg;
		log(new Status(IStatus.ERROR, plugin.getBundle().getSymbolicName(),
				IStatus.ERROR, reportMsg, throwable));
	}

	/**
	 * Logs a message from the specified <code>status</code>.
	 */
	public void log(IStatus status) {
		plugin.getLog().log(status);
	}
}
