/*
 * Copyright (C) ILOG 2006. All rights reserved.
 * 
 * THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OR ANY KIND
 * EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MECHANTABILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
 */
package ilog.contrib.rules.studio.bomdomainpopulate.actions;

import ilog.rules.bom.IlrObjectModel;
import ilog.rules.studio.model.IlrElement;
import ilog.rules.studio.model.IlrStudioModelPlugin;
import ilog.rules.studio.model.bom.IlrBOM;
import ilog.rules.studio.model.bom.IlrBOMEntry;
import ilog.rules.util.IlrVisitor;

import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IActionDelegate;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;

public class UpdateBomDomainAction implements IObjectActionDelegate {

	private IlrBOMEntry bomentry;

	/**
	 * @see IObjectActionDelegate#setActivePart(IAction, IWorkbenchPart)
	 */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	/**
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {
		Shell shell = new Shell();
		IlrBOM bom = bomentry.getBOM();
		IlrObjectModel objectmodel = bom.getObjectModel();
		objectmodel.accept(new IlrVisitor() {
			public void visit(Object o) {
				// visit the BOM as needed
			}
		});
		MessageDialog.openInformation(shell, "BomDomainPopulate Plug-in",
				"Update BOM Domain was executed for " + bomentry);
	}

	/**
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
		if (selection instanceof IStructuredSelection) {
			Object obj = ((IStructuredSelection) selection).getFirstElement();
			if (obj instanceof IAdaptable) {
				IAdaptable adaptable = (IAdaptable) obj;
				IResource resource = (IResource) adaptable
						.getAdapter(IResource.class);
				// Retrieve the IlrElement attached to this resource, thanks to
				// the IlrResourceManager
				IlrElement elt = IlrStudioModelPlugin.getResourceManager()
						.getElementFromResource(resource);
				if (elt instanceof IlrBOM) {
					bomentry = ((IlrBOM) elt).getBOMEntry();
				}
			}
		}
	}
}
